//+------------------------------------------------------------------+
//|                                                    ma_digits.mq4 |
//|                      Copyright  2008, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//|                                                           KONDOR |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1 DeepPink

//     28   

string Val[8] ={"EUR","GBP","AUD","NZD","USD","CAD","CHF","JPY"};

 color col[8]={Red,Violet,Yellow,LightSeaGreen,Lime,Aqua,Orange,FireBrick};
 
  string simb[28]={
 "EURGBP","EURAUD","EURNZD","EURUSD","EURCAD","EURCHF","EURJPY",
 "GBPAUD","GBPNZD","GBPUSD","GBPCAD","GBPCHF","GBPJPY","AUDNZD",
 "AUDUSD","AUDCAD","AUDCHF","AUDJPY","NZDUSD","NZDCAD","NZDCHF",
 "NZDJPY","USDCAD","USDCHF","USDJPY","CADCHF","CADJPY","CHFJPY"};

 int xtot=100;   int y=10;


double MA[];


extern int MAPeriod=50;

extern int ma_metod=MODE_LWMA;
extern int price_type=MODE_CLOSE;

extern bool alert_Val=false;

datetime old_time= D'2009.01.01 00:00';

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators

IndicatorBuffers(1);
SetIndexStyle(0,DRAW_LINE);
SetIndexBuffer(0,MA);

 for(int a=0;a<8;a++) { 
  ObjectDelete(Val[a]);
  Create_Tic( Val[a]+"MA2",Val[a],xtot+65   , y+a*15, col[a]); 
  } 
//----
   return(0);
  }

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   

 
 double old_bid[8][28]={
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,};
                         
int count[8][28]={
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,};
  
int koef[8][28]={
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,};

double count_k[28]={0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};

double n_k[8]={0,0,0,0,0,0,0,0}, old_n_k[8]={0,0,0,0,0,0,0,0} ;


 
   int n[8]={0,0,0,0,0,0,0,0}, old_n[8]={0,0,0,0,0,0,0,0} ;
   
   
 



 for(int a=0;a<8;a++) {    
    
   for(int g=0;g<28;g++){  
     
        if( StringFind(simb[g],Val[a],0)>=0) { 
            
            if(StringFind(simb[g],Val[a],0)==0) 
             koef[a,g]=1; else  koef[a,g]=-1; 

             //iClose(simb[g],0,0)>iMA(simb[g],0,MAPeriod,0,ma_metod,price_type,0)
             
            if(iClose(simb[g],0,0)>iOpen(simb[g],0,0))
             count[a,g]=1;  else count[a,g]=-1; 
             
            count_k[g]=delta(simb[g], MAPeriod,ma_metod,price_type);  
                
             old_bid[a,g]=iClose(simb[g],0,0);  n[a]+= count[a,g]*koef[a,g];  }  n_k[a]+= koef[a,g]*count_k[g];
                
                
     }        
//--------------------------------------------------------------     
 if(n[a]!=old_n[a]){

   {ObjectDelete(Val[a]);Create_Tic( Val[a]+"MA",DoubleToStr(n  [a],0),xtot   , y+a*15, col[a]); } 
   
   {ObjectDelete(Val[a]);Create_Tic( Val[a]     ,DoubleToStr(n_k[a],3),xtot+20, y+a*15, col[a]); }

 //Alert(Val[a],"  ",old_n[a]);

 old_n[a]=n[a];   }        
 
               } 
               
          
//-------------------------------------------------------------              
   string Val_max;  double max=0; string text_alert="";
                   
      for( g=0;g<28;g++){ 
      
        if(delta_mat(simb[g], MAPeriod,ma_metod,price_type)> max) {max=delta(simb[g], MAPeriod,ma_metod,price_type); Val_max=simb[g];
        
       {if(delta    (simb[g], MAPeriod,ma_metod,price_type)>0) text_alert="Val_max ";else text_alert="Val_min ";} }
        }            
      if(old_time!=Time[0] && alert_Val==true) { Alert(text_alert,Val_max,"=  ",max,"  ",Period()); old_time=Time[0]; }              
 //-------------------------------------------------------------           
 
                    
 for(int i=0;i<500;i++){
 MA[i]=iMA(Symbol(),0,MAPeriod,0,ma_metod,price_type,i);  }
   
    
  
//----
   return(0);
  }
//+------------------------------------------------------------------+


//----------------------------------------------------------------
   
 int deinit()
  {
//----
for(int a=0;a<8;a++){
   ObjectDelete(Val[a]+"MA2");
   ObjectDelete(Val[a]+"MA"); 
   ObjectDelete(Val[a]);     }
//----
   return(0);
  }
  
  
//----------------------------------------------------------------  

int Create_Tic(string name,string text,int x,int y, color  c)      
  {                                           
   ObjectCreate(name,OBJ_LABEL, 0, 0,0); 
   ObjectSetText(name, text, 9, "Tahoma Narrow", c);
   ObjectSet(name, OBJPROP_CORNER, 3);     
   ObjectSet(name, OBJPROP_XDISTANCE, x); 
   ObjectSet(name,OBJPROP_YDISTANCE,y);
   return;                                      
  }

//---------------------------------------------------------------
double delta    (string s,int MAPeriod,int ma_metod,int price_type){
 return (       (iClose(s,0,0)-iMA(s,0,MAPeriod,0,ma_metod,price_type,0) )/iMA(s,0,MAPeriod,0,ma_metod,price_type,0)*100);  }
 
double delta_mat(string s,int MAPeriod,int ma_metod,int price_type){
 return (MathAbs(iClose(s,0,0)-iMA(s,0,MAPeriod,0,ma_metod,price_type,0) )/iMA(s,0,MAPeriod,0,ma_metod,price_type,0)*100);  }
 
  